<?php
   /*
     * $Id: cache.php 1129 2006-12-21 00:54:50Z dmorton $
     *
     * MAIA MAILGUARD LICENSE v.1.0
     *
     * Copyright 2004 by Robert LeBlanc <rjl@renaissoft.com>
     *                   David Morton   <mortonda@dgrmm.net>
     * All rights reserved.
     *
     * PREAMBLE
     *
     * This License is designed for users of Maia Mailguard
     * ("the Software") who wish to support the Maia Mailguard project by
     * leaving "Maia Mailguard" branding information in the HTML output
     * of the pages generated by the Software, and providing links back
     * to the Maia Mailguard home page.  Users who wish to remove this
     * branding information should contact the copyright owner to obtain
     * a Rebranding License.
     *
     * DEFINITION OF TERMS
     *
     * The "Software" refers to Maia Mailguard, including all of the
     * associated PHP, Perl, and SQL scripts, documentation files, graphic
     * icons and logo images.
     *
     * GRANT OF LICENSE
     *
     * Redistribution and use in source and binary forms, with or without
     * modification, are permitted provided that the following conditions
     * are met:
     *
     * 1. Redistributions of source code must retain the above copyright
     *    notice, this list of conditions and the following disclaimer.
     *
     * 2. Redistributions in binary form must reproduce the above copyright
     *    notice, this list of conditions and the following disclaimer in the
     *    documentation and/or other materials provided with the distribution.
     *
     * 3. The end-user documentation included with the redistribution, if
     *    any, must include the following acknowledgment:
     *
     *    "This product includes software developed by Robert LeBlanc
     *    <rjl@renaissoft.com>."
     *
     *    Alternately, this acknowledgment may appear in the software itself,
     *    if and wherever such third-party acknowledgments normally appear.
     *
     * 4. At least one of the following branding conventions must be used:
     *
     *    a. The Maia Mailguard logo appears in the page-top banner of
     *       all HTML output pages in an unmodified form, and links
     *       directly to the Maia Mailguard home page; or
     *
     *    b. The "Powered by Maia Mailguard" graphic appears in the HTML
     *       output of all gateway pages that lead to this software,
     *       linking directly to the Maia Mailguard home page; or
     *
     *    c. A separate Rebranding License is obtained from the copyright
     *       owner, exempting the Licensee from 4(a) and 4(b), subject to
     *       the additional conditions laid out in that license document.
     *
     * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER AND CONTRIBUTORS
     * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
     * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
     * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
     * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
     * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
     * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
     * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
     * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
     * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
     * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
     *
     */
class MessageCache {
    
    var $type;
    var $dbh;
    var $smarty;
    var $sortby;
    var $sort_order;
    var $select_stmt;
    
    function MessageCache($type, & $dbh, & $smarty) {
        $this->smarty =& $smarty;
        $this->dbh =& $dbh;
        $this->type = $type;
        $this->smarty->assign("cache_type", $type);
        $this->sortby= array();
    }
    
    function get_offset() {
        global $_GET;
        return isset($_GET["offset"]) ? $_GET["offset"] : 0;
    }
    
    function get_sort_field() {
        switch ($this->type) {
                case "ham": $field = "ham_cache_sort";
                    break;
                case "spam": $field = "spam_quarantine_sort";
                    break;
                case "virus": $field = "virus_quarantine_sort";
                    break;
                case "attachment": $field = "attachment_quarantine_sort";
                    break;
                case "header": $field = "header_quarantine_sort";
                    break;
                default: $field = "ham_cache_sort";
        }
        $this->sort_field = $field;
        return $field;
    
    }
    
    function get_sort_abbrev() {
        switch ($this->type) {
            case "ham": $field = "H";
                    break;
            case "spam": $field = "S";
                break;
            case "virus": $field = "V";
                break;
            case "attachment": $field = "F";
                break;
            case "header": $field = "B";
                break;
            default: $field = "H";
        }
        return $field;
    }
    
    function set_sort_order($sort, $euid, $sid) {
        global $_GET;
         $field = $this->get_sort_field();

         $sort = strtoupper(trim($_GET["sort"]));
         if (strlen($sort) == 2) {
             switch($sort[0]) {
                 case "X":
                 case "D":
                 case "F":
                 case "S":
                     if ($sort[1] == "A" || $sort[1] == "D") {
                         $update = "UPDATE maia_users SET ". $field ." = ? WHERE id = ?";
                         $this->dbh->query($update, array($sort, $euid));
                         header("Location: list-cache.php" . $sid. "?cache_type=". $this->type);
                         exit;
                     }
                     break;
                 default:
                     break;
             }
            
         }
    }
    
    function get_sort_order($euid) {
        global $dbh, $msid, $sid;
        $sort = strtoupper(get_user_value($euid, $this->get_sort_field()));
             switch($sort[0]) {
                 case "X":
                     $this->sortby['score'] = ($sort[1] == "A" ? "xd" : "xa"); //FIXME - depends on spam/ham/other
                     $this->sortby['column'] = "score";
                     $this->sortby['date'] = "da";
                     $this->sortby['from'] = "fa";
                     $this->sortby['subject'] = "sa";
                     break;
                 case "D":
                     $this->sortby['score'] = "xa"; //FIXME - depends on spam/ham/other
                     $this->sortby['column'] = "received_date";
                     $this->sortby['date'] = ($sort[1] == "A" ? "dd" : "da");
                     $this->sortby['from'] = "fa";
                     $this->sortby['subject'] = "sa";
                     break;
                 case "F":
                     $this->sortby['score'] = "xa"; //FIXME - depends on spam/ham/other
                     $this->sortby['column'] = "sender_email";
                     $this->sortby['date'] = "da";
                     $this->sortby['from'] = ($sort[1] == "A" ? "fd" : "fa");
                     $this->sortby['subject'] = "sa";
                     break;
                 case "S":
                     $this->sortby['score'] = "xa"; //FIXME - depends on spam/ham/other
                     $this->sortby['column'] = "subject";
                     $this->sortby['date'] = "da";
                     $this->sortby['from'] = "fa";
                     $this->sortby['subject'] = ($sort[1] == "A" ? "sd" : "sa");
                     break;
                 default:
                     $this->sortby['score'] = "xa"; //FIXME - depends on spam/ham/other
                     $this->sortby['column'] = "score";
                     $this->sortby['date'] = "da";
                     $this->sortby['from'] = "fa";
                     $this->sortby['subject'] = "sa";
             }
             if ($sort[1] == "D") {
                 $this->sort_order = "DESC";
             } else {
                 $this->sort_order = "ASC";
             }
             $this->smarty->assign("sortby", $this->sortby);
             $this->smarty->assign("sort_order", $this->sort_order);
    }
    
    function set_select() {
        if ($this->type == 'attachment') {
            $extra_select   = ",maia_banned_attachments_found.file_name, maia_banned_attachments_found.file_type ";
            $extra_join     = "LEFT JOIN maia_banned_attachments_found ON maia_mail.id = maia_banned_attachments_found.mail_id ";
        } elseif ($this->type == "virus") {
            $extra_select   = ",maia_viruses.virus_name ";
            $extra_join     = "LEFT JOIN maia_viruses_detected on maia_viruses_detected.mail_id = maia_mail.id " .
                              "LEFT JOIN maia_viruses ON maia_viruses.id = maia_viruses_detected.virus_id ";              
        } else {
            $extra_select = "";
            $extra_join = "";
        }
            
        $this->select_count = "SELECT COUNT(maia_mail.id) " .
              "FROM maia_mail_recipients " .
              "LEFT JOIN maia_mail " .
              "ON maia_mail.id = maia_mail_recipients.mail_id " .
              "WHERE maia_mail_recipients.type = '". $this->get_sort_abbrev() ."' " .
              "AND maia_mail_recipients.recipient_id = ? ";

        $this->select_stmt = "SELECT maia_mail.id, maia_mail.received_date, maia_mail.score, " .
                "maia_mail.sender_email, maia_mail.subject, maia_mail.envelope_to " .
                $extra_select . 
                "FROM maia_mail_recipients " .
                "LEFT JOIN maia_mail " .
                "ON maia_mail.id = maia_mail_recipients.mail_id " .
                $extra_join .
		"WHERE maia_mail_recipients.type = '". $this->get_sort_abbrev() ."' " .
                "AND maia_mail_recipients.recipient_id = ? " . 
                " ORDER BY maia_mail." . $this->sortby['column'] . " " . $this->sort_order;
    }
    
    function confirm_cache($euid) {    
      $message = "";
      $confirmed = 0;
      $reported = 0;
      $deleted = 0;
      $rescued = 0;
      
      $ham_list = array();
      $spam_list = array();
      $delete_list = array();
      $resend_list = array();
      
      global $_POST, $lang, $logger;
      $items = $_POST['cache_item'];
      foreach ($items as $type => $mail_item) {
        foreach ($mail_item as $mail_id => $value) {
          if ($type == "generic") {
              $newtype = $_POST['submit'];
          } else {
              $newtype = $value;
          }
          // report item
          if ($newtype == "spam") {
            switch ($this->type) {
              case 'ham':
                // Mark the item as false negative.   It will also be marked as confirmed.               
                record_mail_stats($euid, $mail_id, "fn");
                $reported++;
                break;
              default:
                $confirmed++;
            }
            array_push($spam_list, $mail_id);
            
          //send item
          } elseif ($newtype == "ham") {
            switch ($this->type) {
              case 'ham':
                  array_push($ham_list, $mail_id);
                $confirmed++;
                break;
              default:
                $result = rescue_item($euid, $mail_id); // done individually because of mail delivery
                if (strncmp($result, "2", 1) == 0) {
                  $rescued++;
                } else {
                $message .= $result . "\n";                    
                }                      
            }              
          //delete item.
          } elseif ($newtype == "delete") {
              array_push($delete_list, $mail_id);
              $deleted++;
          // resend the item and leave it in the cache
          } elseif ($newtype == "resend") {
             array_push($resend_list, $mail_id);
             $resent++;
          }
        }
      }
      
      if (count($ham_list) > 0)      { confirm_ham($euid, $ham_list );   }
      if (count($spam_list) > 0)    { confirm_spam($euid, $spam_list);   }
      if (count($delete_list) > 0 ) { delete_mail_reference($euid, $delete_list); }
      if (count($resend_list) > 0 ) { resend_message($euid, $resend_list); }

      update_mail_stats($euid, "suspected_ham");
      if ($confirmed > 0) {
        if ($this->type == "ham") {    
          $message .= sprintf($lang['text_ham_confirmed'], $confirmed) . ".<br>";
        } else {
          $message .= sprintf($lang['text_spam_confirmed'], $confirmed) . ".<br>";
        }
      }

      if ($reported > 0) {
          $message .= sprintf($lang['text_spam_reported'], $reported) . ".<br>";
      }
      if ($deleted > 0) {
        if ( $this->type == "ham") {
          $message .= sprintf($lang['text_ham_deleted'], $deleted) . ".<br>";
        } else {
          $message .= sprintf($lang['text_spam_deleted'], $deleted) . ".<br>";        
        }
      }
      if ($rescued > 0) {
        $message .= sprintf($lang['text_spam_rescued'], $rescued) . ".<br>";
      }
      if ($resent > 0) {
        $message .= sprintf($lang['text_message_resent'], $resent) . ".<br>";
      }
      $this->smarty->assign("message", $message);
      return $message;
    
    }
    
    function render($euid) {
        global $lang, $sid, $msid, $html_charset, $offset, $message;
        $magic_quotes = get_magic_quotes_gpc();
        $nothing_to_show = true;
        $offset = 0;
        $this->smarty->assign("msid", $msid);
        $this->smarty->assign("lang", $lang);
        $user_config = get_maia_user_row($euid);
		
		//set the class names for the given cache type, and default box to check.
		switch ($this->type) {
			case 'ham':
                $this->smarty->assign("banner_class", "hambanner");
				$this->smarty->assign("header_class", "hamheader");
				$this->smarty->assign("body_class", "hambody");
				$this->smarty->assign("alt_body_class", "hambody_alt");
				$this->smarty->assign("header_text", $lang['header_suspected_ham']);
                $this->smarty->assign("def_rb", "ham");
				break;
		    case 'spam': 
                $this->smarty->assign("banner_class", "suspected_spambanner");
				$this->smarty->assign("header_class", "suspected_spamheader");
				$this->smarty->assign("body_class", "suspected_spambody");
				$this->smarty->assign("alt_body_class", "suspected_spambody_alt");
				$this->smarty->assign("header_text", $lang['header_spam']);
                $this->smarty->assign("def_rb", "spam");
				break;
			case "virus": 
                $this->smarty->assign("banner_class", "virusbanner");
				$this->smarty->assign("header_class", "virusheader");
				$this->smarty->assign("body_class", "virusbody");
				$this->smarty->assign("alt_body_class", "virusbody_alt");
				$this->smarty->assign("header_text", $lang['header_viruses']);
                $this->smarty->assign("def_rb", "delete");
				break;
            case "attachment":  
                $this->smarty->assign("banner_class", "banned_filebanner");
				$this->smarty->assign("header_class", "banned_fileheader");
				$this->smarty->assign("body_class", "banned_filebody");
				$this->smarty->assign("alt_body_class", "banned_filebody_alt");
				$this->smarty->assign("header_text", $lang['header_banned_files']);
                $this->smarty->assign("def_rb", "delete");
				break;
            case "header":  
                $this->smarty->assign("banner_class", "bad_headerbanner");
				$this->smarty->assign("header_class", "bad_headerheader");
				$this->smarty->assign("body_class", "bad_headerbody");
				$this->smarty->assign("alt_body_class", "bad_headerbody_alt");
				$this->smarty->assign("header_text", $lang['header_bad_headers']);
                $this->smarty->assign("def_rb", "delete");
				break;
			
		}

        $numRows = $this->dbh->getOne($this->select_count, array($euid));
  
        if ($numRows > 0)
        {
            $select2 = "SELECT email FROM users WHERE maia_user_id = ?";
            $sth2 = $this->dbh->query($select2, array($euid));
            while ($row2 = $sth2->fetchrow()) {
                $personal_addresses[] = $row2["email"];
            }
            $sth2->free();
            $personal_addresses = array_flip($personal_addresses);
            $domain_default = is_a_domain_default_user($euid);
            
            $need_to = (count($personal_addresses) > 1 || $domain_default);
             if ($need_to) {
                 $cols = 8;
             } else {
                 $cols = 7;
             }
              $this->smarty->assign("need_to", $need_to);
            
            $per_page = get_user_value($euid, "items_per_page");

            $this->smarty->assign("truncate_subject", $user_config["truncate_subject"] == 0 ? 10000 : $user_config["truncate_subject"] );
            $this->smarty->assign("truncate_email", $user_config["truncate_email"] == 0 ? 10000 : $user_config["truncate_email"] );

            
            $pagerOptions = array(
                                   'mode'    => 'Sliding',
                                   'delta'   => 5,
                                   'perPage' => $per_page,
                                   'totalItems' => $numRows,
                                   );

            $paged_data = Pager_Wrapper_DB($this->dbh, $this->select_stmt, $pagerOptions, null, DB_FETCHMODE_ASSOC, array($euid));
            //$paged_data['data'];  //paged data
            //$paged_data['links']; //xhtml links for page navigation
            //$paged_data['page_numbers']; //array('current', 'total');
            if (PEAR::isError($paged_data)) {
                $_SESSION["message"] = $paged_data->getMessage();
                header("Location: welcome.php" . $sid);
                exit;
            }   
             $maxid = 0;
             $nothing_to_show = false;
       
             $this->smarty->assign("data", $paged_data['data']);
             $this->smarty->assign("offset", $offset);
             //print_r($paged_data['page_numbers']);
             $this->smarty->assign("pages", $paged_data['page_numbers']);
        
            if ($numRows == 1) {
                $item_text = $lang['text_item'];
            } else {
                $item_text = $lang['text_items'];
            }

            $count = 0;
            $rows = array();
        
              foreach ($paged_data['data'] as $row)
              {
                if ($row["id"] > $maxid) {
                      $maxid = $row["id"];
                }

                $rows[$count]['id'] = $row['id'];
                if ($this->type == 'attachment' ) {
                  $rows[$count]['file'] = $row['file_name'] . " (" . $row['file_type'] . ")";
                  //$cols += 1;
                } elseif ($this->type == 'virus') {
                    $vurl = get_virus_info_url($row["virus_name"]);
                    if ($vurl == "") {
                        $rows[$count]['virus_name'] = $row["virus_name"];
                    } else {
                        $rows[$count]['virus_name'] = "<a href=\"" . $vurl . "\">" . $row["virus_name"] . "</a>";
                    }
                    $rows[$count]['virus_name'] .= "<br>";
                    //$cols += 1;
                }
                $rows[$count]['received_date'] = $row["received_date"];
                $rows[$count]['sender_email'] = $magic_quotes ? stripslashes($row["sender_email"]) : $row["sender_email"];
                $rows[$count]['score'] = $row['score'];
 
                    $to_list = explode(" ", $row["envelope_to"]);
                    $rectmp = "";
                    foreach ($to_list as $recipient) {
                        if (isset($personal_addresses[$recipient]) || $domain_default) {
                          $rectmp[] = $recipient;
                        }
                    }
                    $rows[$count]['recipient_email'] = $rectmp;

           $subject = trim(htmlentities($magic_quotes ? stripslashes($row['subject']) : $row['subject']));
           if ($subject == "") {
              $subject = "(" . $lang['text_no_subject'] . ")";
           }else{
                 $subject = decode_header($subject, $html_charset);
           }
                  $rows[$count]['subject'] = $subject;
                  $count++;
          }

              $this->smarty->assign("row", $rows); 
              $this->smarty->assign("maxid", $maxid);

              $this->smarty->assign("links", $paged_data['links']);
        } else {
            $_SESSION["message"] = $message;
            header("Location: welcome.php" . $sid);
            exit;
        }
        //$this->smarty->assign("cols", $cols);   
        $this->smarty->assign("nothing_to_show", $nothing_to_show);   
        $this->smarty->display("list-cache.tpl");
    }
    
}
?>
