<?php
    /*
     * $Id$
     *
     * MAIA MAILGUARD LICENSE v.1.0
     *
     * Copyright 2004 by Robert LeBlanc <rjl@renaissoft.com>
     * All rights reserved.
     *
     * PREAMBLE
     *
     * This License is designed for users of Maia Mailguard
     * ("the Software") who wish to support the Maia Mailguard project by
     * leaving "Maia Mailguard" branding information in the HTML output
     * of the pages generated by the Software, and providing links back
     * to the Maia Mailguard home page.  Users who wish to remove this
     * branding information should contact the copyright owner to obtain
     * a Rebranding License.
     *
     * DEFINITION OF TERMS
     *
     * The "Software" refers to Maia Mailguard, including all of the
     * associated PHP, Perl, and SQL scripts, documentation files, graphic
     * icons and logo images.
     *
     * GRANT OF LICENSE
     *
     * Redistribution and use in source and binary forms, with or without
     * modification, are permitted provided that the following conditions
     * are met:
     *
     * 1. Redistributions of source code must retain the above copyright
     *    notice, this list of conditions and the following disclaimer.
     *
     * 2. Redistributions in binary form must reproduce the above copyright
     *    notice, this list of conditions and the following disclaimer in the
     *    documentation and/or other materials provided with the distribution.
     *
     * 3. The end-user documentation included with the redistribution, if
     *    any, must include the following acknowledgment:
     *
     *    "This product includes software developed by Robert LeBlanc
     *    <rjl@renaissoft.com>."
     *
     *    Alternately, this acknowledgment may appear in the software itself,
     *    if and wherever such third-party acknowledgments normally appear.
     *
     * 4. At least one of the following branding conventions must be used:
     *
     *    a. The Maia Mailguard logo appears in the page-top banner of
     *       all HTML output pages in an unmodified form, and links
     *       directly to the Maia Mailguard home page; or
     *
     *    b. The "Powered by Maia Mailguard" graphic appears in the HTML
     *       output of all gateway pages that lead to this software,
     *       linking directly to the Maia Mailguard home page; or
     *
     *    c. A separate Rebranding License is obtained from the copyright
     *       owner, exempting the Licensee from 4(a) and 4(b), subject to
     *       the additional conditions laid out in that license document.
     *
     * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER AND CONTRIBUTORS
     * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
     * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
     * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
     * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
     * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
     * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
     * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
     * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
     * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
     * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
     *
     */
    $lang['text_welcome_greeting'] = "Welcome to Maia Mailguard!";
    $lang['text_welcome_first_time'] = "Welcome to Maia Mailguard. I see this is the first time you have logged in. Please read this message completely, as it will help you understand
                                        the importantance of your participation in stopping spam.<P>
                                        First of all, to turn on spam protection quickly, just choose a level below and click on \"Change Level\".  The \"high\" level is perfectly safe, and recommended.
                                        <P>Maia Mailguard can filter your email, and can block most of the unwanted content from arriving in your inbox.  If it makes a mistake, however, not all is lost.
                                        Maia can quarantine your email away, accessable on this page, for you to \"rescue\", or \"report\" to authorities.  It also allows you to train the filter when a
                                        piece of spam gets through, by reporting it from your \"non-spam cache\" - a collection of recent emails that it considered to be good email.";
    $lang['text_welcome_intro'] = "<p>Take action against the onslaught of unwanted email with Maia Mailguard.  When mail is listed in the lower right pane, you can
                                    train Maia regarding the difference between good email (non-spam) and unwanted email (spam).  Please take the time to be sure that 
                                    all items are reported correctly; if you don't have time to do so, please delete all the items rather than reporting them 
                                    incorrectly.<p>
                                    Keep in mind, Maia can and will report items confirmed as spam to other services and authorities.  By keeping up with the reporting process, 
                                    you can help fight the spam war.";
    $lang['text_welcome_current_level'] = "Current protection level:"; 
    $lang['text_welcome_custom_level'] = "**Custom levels are in use:<br>Use settings screen to manage, or choose a preset level above.";
    $lang['header_cache_contents'] = "Cache Contents";
    
    $lang['text_suspected_spam_item']= "Suspected Spam:";
    $lang['text_suspected_ham_item'] = "Unconfirmed Non-spam:";
    $lang['text_virus_item'] =  "Virus/Malware:";
    $lang['text_banned_file_item'] =  "Banned Files:";
    $lang['text_bad_header_item'] =  "Corrupt E-mails:";
    
    $lang['text_welcome_spam_blocked'] = "SPAM items have been blocked for you";
    $lang['text_welcome_virus_blocked'] = "Viruses have been blocked for you";
    $lang['text_welcome_spam_blocked_system'] = "Spam items blocked systemwide";
    $lang['text_welcome_virus_blocked_system'] = "Viruses blocked systemwide";
    $lang['button_delete_all_items'] = "Delete all items";
    $lang['button_change_protection'] = "Change Level";
    
    $lang['radio_protection'] = array(  'off' => "Off",
		 								'low' => "Low",
     									'medium' => "Medium",
										'high' => "High",
										'custom' => "Custom");
    
    $lang['banner_subtitle'] = "Welcome";
    
    $lang['text_cache_spam'] = "You have <b>%d</b> items in your spam cache.  <br>Click <a href=\"%s\">here</a> to report it, or to rescue a message that was mistakenly blocked.";
    $lang['text_cache_virus'] = "You have <b>%d</b> items in your virus cache.  <br>Click <a href=\"%s\">here</a> to delete it, or to rescue a message that was mistakenly blocked.";
    $lang['text_cache_banned'] = "You have <b>%d</b> items in your banned-file cache.  <br>Click <a href=\"%s\">here</a> to delete it, or to rescue a message that was mistakenly blocked.";
    
    $lang['text_cache_header'] = "You have <b>%d</b> items in your bad-header cache.  <br>Click <a href=\"%s\">here</a> to delete it, or to rescue a message that was mistakenly blocked.";
    $lang['text_cache_ham'] = "You have <b>%d</b> items in your non-spam cache.  <br>Click <a href=\"%s\">here</a> to help train the filter, or to report a spam message that was missed.";
    $lang['action_ham_cache']   = "Report/Confirm";
    $lang['action_spam_cache']  = "Report/Rescue";
    $lang['action_virus_cache'] = "Delete/Rescue";
    $lang['action_banned_cache'] = "Delete/Rescue";
    $lang['action_header_cache'] = "Delete/Rescue";
